<template>
  <div id="q-app">
    
      <router-view></router-view>

  </div>
</template>

<script>
import Vue from 'vue';
import VueCookies from 'vue-cookies';
import Store from './store/index';
import api from './boot/backend-api';
VueCookies.config('7d');

import VueTour from 'vue-tour';
require('vue-tour/dist/vue-tour.css');
Vue.use(VueTour);

export default {
  name: 'App',
  data () {
    return {
      store: Store
    }
  },
  mounted() {

    this.store.watch(
      state => state.connected,
      () => {
        if(this.store.getters.isConnected){
          // console.log('trying subscribe');
          this.store.getters.getStompClient.subscribe('/topic/public', this.onPublicReceived);
        }
      }
    );

    api.getLoggedUsers().then( response => { this.store.commit('update_logged_users', {users: response.data}); }).catch(error => {console.log(error);})
    

    this.$q.loadingBar.start();
    var token = VueCookies.get('axesstoken');
    
    if(token) {
      let tokenParsed = this.parseJwt(token);
      let promise = api.getPersonalInfos()
      promise.then(response => {
        this.store.dispatch('connectSocket');
        // this.store.commit('connect_socket');
        this.store.commit('update_user', {user: response.data});
        this.store.commit('login_success', { userName: tokenParsed.user_name });
        // this.$store.getters.getStompClient.subscribe('/topic/public', this.onPublicReceived);
        this.$q.loadingBar.stop();
      }).catch( error => {
        this.store.commit('update_user', {user: {  username: '',firstName: '',lastName: '', age: null, gender: '', email: '', organization: '', status: '', avatar: '' }});
        this.store.commit('logout_success');
        this.$q.loadingBar.stop();
        this.store.dispatch("logout", { user: tokenParsed.user_name})
        .then(() => {
          this.$router.push('/');
        })
      });
      
    }else{
      this.store.commit('login_error', { userName: '' });
      this.$q.loadingBar.stop();
    }
  },
  methods: {
    parseJwt: function (token) {
      var base64Url = token.split('.')[1];
      var base64 = base64Url.replace(/-/g, '+').replace(/_/g, '/');
      var jsonPayload = decodeURIComponent(atob(base64).split('').map(function(c) {
          return '%' + ('00' + c.charCodeAt(0).toString(16)).slice(-2);
      }).join(''));

      return JSON.parse(jsonPayload);
    },
    onPublicReceived: function (payload) {
      var message = JSON.parse(payload.body);
      if(Array.isArray(message)){ this.$store.commit('update_logged_users', {users: message}); }
    }
  }
}
</script>

<style>
</style>
